package cn.com.qmth.examcloud.task.api.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.task.api.ReportsComputeCloudService;
import cn.com.qmth.examcloud.task.api.request.AddReportsComputeReq;
import cn.com.qmth.examcloud.task.api.response.AddReportsComputeResp;
import cn.com.qmth.examcloud.task.service.ReportsComputeService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@Api(tags = "报表计算任务接口")
@RestController
@RequestMapping("${$rmp.cloud.task}" + "reportsCompute")
public class ReportsComputeCloudServiceProvider extends ControllerSupport
		implements
		ReportsComputeCloudService {


	/**
	 * 
	 */
	private static final long serialVersionUID = -8948562824083405677L;
	@Autowired
	private ReportsComputeService reportsComputeService;

	@ApiOperation(value = "新增报表计算任务")
	@PostMapping("/add")
	@Override
	public AddReportsComputeResp addReportsCompute(@RequestBody AddReportsComputeReq req) {
		Long projectId=req.getProjectId();
		if(projectId==null) {
			throw new StatusException("10001", "projectId不能为空");
		}
		Long rootOrgId=req.getRootOrgId();
		if(rootOrgId==null) {
			throw new StatusException("10002", "rootOrgId不能为空");
		}
		reportsComputeService.add(projectId, rootOrgId);
		return new AddReportsComputeResp();
	}


}
