package cn.com.qmth.examcloud.task.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import cn.com.qmth.examcloud.task.base.enums.ReportsComputeStatus;
import cn.com.qmth.examcloud.task.dao.entity.ReportsComputeEntity;

@Repository
public interface ReportsComputeRepo
		extends
			JpaRepository<ReportsComputeEntity, Long>,
			JpaSpecificationExecutor<ReportsComputeEntity> {
	@Query(value = "SELECT count(1) FROM EC_T_REPORTS_COMPUTE t "+
			"WHERE t.status ='NONE' or t.status ='STOPING' ", nativeQuery = true)
	public int getTodoDataCount();
	@Query(value = "SELECT t.* FROM EC_T_REPORTS_COMPUTE t "+
			"WHERE t.id>?1 and (t.status ='NONE' or t.status ='STOPING') ORDER BY t.id limit ?2", nativeQuery = true)
	public List<ReportsComputeEntity> findTodoData(Long startId,Integer limit);
	
	@Query(value = "update EC_T_REPORTS_COMPUTE t set t.status ='STOPING' where t.id=?1 and (t.status ='COMPUTING' or t.status ='NONE') ", nativeQuery = true)
	@Modifying
	public int updateToStoping(Long id);
	
	@Query(value = "update EC_T_REPORTS_COMPUTE t set t.status ='STOP' where t.status ='STOPING' ", nativeQuery = true)
	@Modifying
	public int initStopingJob();
	
	@Query(value = "update EC_T_REPORTS_COMPUTE t set t.status ='NONE' where t.status ='COMPUTING' ", nativeQuery = true)
	@Modifying
	public int initComputingJob();

	public List<ReportsComputeEntity> findByProjectIdAndRootOrgIdAndStatus(Long projectId, Long rootOrgId,ReportsComputeStatus status);

	public List<ReportsComputeEntity> findByStatus(ReportsComputeStatus status);
	
	@Query(value = "select * from EC_T_REPORTS_COMPUTE where id in(?1) and root_org_id=?2 ", nativeQuery = true)
	public List<ReportsComputeEntity> getByIds(List<Long> ids, Long rootOrgId);
}
