package cn.com.qmth.examcloud.task.dao;

import java.util.Date;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import cn.com.qmth.examcloud.task.dao.entity.TaskTraceEntity;

@Repository
public interface TaskTraceRepo
		extends
			JpaRepository<TaskTraceEntity, Long>,
			JpaSpecificationExecutor<TaskTraceEntity> {

	TaskTraceEntity findByTraceId(String traceId);

	@Transactional
	@Modifying
	@Query(value = "delete from EC_T_TASK_TRACE where creation_time < ?1", nativeQuery = true)
	void deleteByCreationTimeLessThan(Date date);

}
