package cn.com.qmth.examcloud.task.dao.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

import cn.com.qmth.examcloud.task.dao.enums.CopyExamStudentStatus;
import cn.com.qmth.examcloud.web.jpa.JpaEntity;

/**
 * 考生复制
 *
 * @author WANGWEI
 * @date 2018年8月2日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Entity
@Table(name = "EC_T_COPY_EXAM_STUDENT")
@IdClass(CopyExamStudentPK.class)
public class CopyExamStudentEntity extends JpaEntity {

	private static final long serialVersionUID = 1066874132817953168L;

	private Long rootOrgId;

	/**
	 * copy from
	 */
	@Id
	private Long examId1;

	/**
	 * copy to
	 */
	@Id
	private Long examId2;

	/**
	 * 考试ID开始值
	 */
	private Long start;

	/**
	 * 状态
	 */
	@Column(nullable = false)
	@Enumerated(EnumType.STRING)
	private CopyExamStudentStatus status;

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public Long getExamId1() {
		return examId1;
	}

	public void setExamId1(Long examId1) {
		this.examId1 = examId1;
	}

	public Long getExamId2() {
		return examId2;
	}

	public void setExamId2(Long examId2) {
		this.examId2 = examId2;
	}

	public Long getStart() {
		return start;
	}

	public void setStart(Long start) {
		this.start = start;
	}

	public CopyExamStudentStatus getStatus() {
		return status;
	}

	public void setStatus(CopyExamStudentStatus status) {
		this.status = status;
	}

}
