package cn.com.qmth.examcloud.task.dao.entity;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;

import cn.com.qmth.examcloud.web.jpa.JpaEntity;

/**
 * 考生临时表
 *
 * @author WANGWEI
 * @date 2018年7月13日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Entity
@Table(name = "EC_T_EXAM_STUDENT_TMP", indexes = {
		@Index(name = "IDX_T_EXAM_STU_001001", columnList = "batchId", unique = false)})
public class ExamStudentTempEntity extends JpaEntity {

	private static final long serialVersionUID = -6030503185547639031L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	/**
	 * 批次ID
	 */
	private Long batchId;

	/**
	 * 状态码
	 */
	private String statusCode;

	/**
	 * 状态描述
	 */
	private String statusDesc;

	/**
	 * 姓名
	 */
	private String name;

	/**
	 * 考试ID
	 */
	private Long examId;

	/**
	 * 学校id
	 */
	private Long rootOrgId;

	/**
	 * 学习中心id
	 */
	private Long orgId;

	/**
	 * 学习中心code
	 */
	private String orgCode;

	/**
	 * 学习中心名称
	 */
	private String orgName;

	/**
	 * 学号
	 */
	private String studentCode;

	/**
	 * 身份证号
	 */
	private String identityNumber;

	/**
	 * 课程ID
	 */
	private Long courseId;

	/**
	 * 课程code
	 */
	private String courseCode;

	/**
	 * 课程名称
	 */
	private String courseName;

	/**
	 * 课程等级
	 */
	private String courseLevel;

	/**
	 * 试卷类型
	 */
	private String paperType;

	/**
	 * 专业名称
	 */
	private String specialtyName;

	/**
	 * 专业code
	 */
	private String specialtyCode;

	/**
	 * 年级
	 */
	private String grade;

	/**
	 * 学生用户id
	 */
	private Long studentId;

	/**
	 * 考点
	 */
	private String examSite;

	/**
	 * 信息采集人
	 */
	private String infoCollector;

	/**
	 * 学生电话
	 */
	private String phone;

	/**
	 * excel行号
	 */
	private Long lineNum;

	/**
	 * 特殊考试批次开始时间
	 */
	private Date specialBeginTime;

	/**
	 * 特殊考试批次结束时间
	 */
	private Date specialEndTime;

	/**
	 * 扩展属性1
	 */
	private String ext1;

	/**
	 * 扩展属性2
	 */
	private String ext2;

	/**
	 * 扩展属性3
	 */
	private String ext3;

	/**
	 * 扩展属性4
	 */
	private String ext4;

	/**
	 * 扩展属性5
	 */
	private String ext5;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getBatchId() {
		return batchId;
	}

	public void setBatchId(Long batchId) {
		this.batchId = batchId;
	}

	public String getStatusCode() {
		return statusCode;
	}

	public void setStatusCode(String statusCode) {
		this.statusCode = statusCode;
	}

	public String getStatusDesc() {
		return statusDesc;
	}

	public void setStatusDesc(String statusDesc) {
		this.statusDesc = statusDesc;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Long getExamId() {
		return examId;
	}

	public void setExamId(Long examId) {
		this.examId = examId;
	}

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public Long getOrgId() {
		return orgId;
	}

	public void setOrgId(Long orgId) {
		this.orgId = orgId;
	}

	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	public String getOrgName() {
		return orgName;
	}

	public void setOrgName(String orgName) {
		this.orgName = orgName;
	}

	public String getStudentCode() {
		return studentCode;
	}

	public void setStudentCode(String studentCode) {
		this.studentCode = studentCode;
	}

	public String getIdentityNumber() {
		return identityNumber;
	}

	public void setIdentityNumber(String identityNumber) {
		this.identityNumber = identityNumber;
	}

	public Long getCourseId() {
		return courseId;
	}

	public void setCourseId(Long courseId) {
		this.courseId = courseId;
	}

	public String getCourseCode() {
		return courseCode;
	}

	public void setCourseCode(String courseCode) {
		this.courseCode = courseCode;
	}

	public String getCourseName() {
		return courseName;
	}

	public void setCourseName(String courseName) {
		this.courseName = courseName;
	}

	public String getCourseLevel() {
		return courseLevel;
	}

	public void setCourseLevel(String courseLevel) {
		this.courseLevel = courseLevel;
	}

	public String getPaperType() {
		return paperType;
	}

	public void setPaperType(String paperType) {
		this.paperType = paperType;
	}

	public String getSpecialtyName() {
		return specialtyName;
	}

	public void setSpecialtyName(String specialtyName) {
		this.specialtyName = specialtyName;
	}

	public String getSpecialtyCode() {
		return specialtyCode;
	}

	public void setSpecialtyCode(String specialtyCode) {
		this.specialtyCode = specialtyCode;
	}

	public String getGrade() {
		return grade;
	}

	public void setGrade(String grade) {
		this.grade = grade;
	}

	public Long getStudentId() {
		return studentId;
	}

	public void setStudentId(Long studentId) {
		this.studentId = studentId;
	}

	public String getExamSite() {
		return examSite;
	}

	public void setExamSite(String examSite) {
		this.examSite = examSite;
	}

	public String getInfoCollector() {
		return infoCollector;
	}

	public void setInfoCollector(String infoCollector) {
		this.infoCollector = infoCollector;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public Long getLineNum() {
		return lineNum;
	}

	public void setLineNum(Long lineNum) {
		this.lineNum = lineNum;
	}

	public Date getSpecialBeginTime() {
		return specialBeginTime;
	}

	public void setSpecialBeginTime(Date specialBeginTime) {
		this.specialBeginTime = specialBeginTime;
	}

	public Date getSpecialEndTime() {
		return specialEndTime;
	}

	public void setSpecialEndTime(Date specialEndTime) {
		this.specialEndTime = specialEndTime;
	}

	public String getExt1() {
		return ext1;
	}

	public void setExt1(String ext1) {
		this.ext1 = ext1;
	}

	public String getExt2() {
		return ext2;
	}

	public void setExt2(String ext2) {
		this.ext2 = ext2;
	}

	public String getExt3() {
		return ext3;
	}

	public void setExt3(String ext3) {
		this.ext3 = ext3;
	}

	public String getExt4() {
		return ext4;
	}

	public void setExt4(String ext4) {
		this.ext4 = ext4;
	}

	public String getExt5() {
		return ext5;
	}

	public void setExt5(String ext5) {
		this.ext5 = ext5;
	}

}
