package cn.com.qmth.examcloud.task.dao.entity;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;

import cn.com.qmth.examcloud.task.base.enums.ReportsComputeStatus;
import cn.com.qmth.examcloud.web.jpa.JpaEntity;

@Entity
@Table(name = "EC_T_REPORTS_COMPUTE", indexes = {
		@Index(name = "IDX_T_REPORTS_COMPUTE_01", columnList = "projectId", unique = false)})
public class ReportsComputeEntity extends JpaEntity {


	/**
	 * 
	 */
	private static final long serialVersionUID = -1847946836121160945L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;
	
	@NotNull
	private Long projectId;
	/**
	 * 顶级机构ID
	 */
	@NotNull
	private Long rootOrgId;
	@NotNull
	@Enumerated(EnumType.STRING)
	private ReportsComputeStatus status;
	
	@Temporal(TemporalType.TIMESTAMP)
	private Date startTime;
	
	@Temporal(TemporalType.TIMESTAMP)
	private Date endTime;

	private String errorDesc;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getProjectId() {
		return projectId;
	}

	public void setProjectId(Long projectId) {
		this.projectId = projectId;
	}

	public ReportsComputeStatus getStatus() {
		return status;
	}

	public void setStatus(ReportsComputeStatus status) {
		this.status = status;
	}

	public Date getStartTime() {
		return startTime;
	}

	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	public String getErrorDesc() {
		return errorDesc;
	}

	public void setErrorDesc(String errorDesc) {
		this.errorDesc = errorDesc;
	}

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}
	
	
}
