package cn.com.qmth.examcloud.task.service.consumer;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import cn.com.qmth.examcloud.core.oe.admin.api.ExamRecordForMarkingCloudService;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamRecordForMarkingBean;
import cn.com.qmth.examcloud.core.oe.admin.api.request.UpdateExamRecordForMarkingBatchNumReq;
import cn.com.qmth.examcloud.examwork.api.ExamStudentCloudService;
import cn.com.qmth.examcloud.examwork.api.bean.ExamCourseRelationBean;
import cn.com.qmth.examcloud.examwork.api.bean.ExamStudentBean;
import cn.com.qmth.examcloud.examwork.api.request.GetExamStudentReq;
import cn.com.qmth.examcloud.examwork.api.response.GetExamStudentResp;
import cn.com.qmth.examcloud.marking.api.StudentPaperCloudService;
import cn.com.qmth.examcloud.marking.api.bean.StudentPaperBean;
import cn.com.qmth.examcloud.marking.api.request.SaveStudentPaperReq;
import cn.com.qmth.examcloud.task.base.multithread.Consumer;
import cn.com.qmth.examcloud.task.service.dto.MarkWorkCreateDto;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

public class MarkWorkCreateConsumer extends Consumer<MarkWorkCreateDto> {

    private StudentPaperCloudService studentPaperCloudService = SpringContextHolder
            .getBean(StudentPaperCloudService.class);

    private ExamStudentCloudService examStudentCloudService = SpringContextHolder
            .getBean(ExamStudentCloudService.class);
    private ExamRecordForMarkingCloudService oeExamRecordForMarkingCloudService = SpringContextHolder
            .getBean(ExamRecordForMarkingCloudService.class);

    @Override
    public void consume(MarkWorkCreateDto dto) {
        List<ExamRecordForMarkingBean> examRecordForMarkingBeanList = dto.getList();
        ExamCourseRelationBean examCourseRelationBean = dto.getExamCourseRelationBean();
        Long workId = dto.getWorkId();
        List<StudentPaperBean> studentPapers = new ArrayList<StudentPaperBean>();
        for (ExamRecordForMarkingBean markingBean : examRecordForMarkingBeanList) {
            GetExamStudentReq getExamStudentReq = new GetExamStudentReq();
            getExamStudentReq.setExamStudentId(markingBean.getExamStudentId());
            GetExamStudentResp getExamStudentResp = examStudentCloudService.getExamStudent(getExamStudentReq);
            ExamStudentBean examStudentBean = getExamStudentResp.getExamStudentBean();
            StudentPaperBean studentPaper = new StudentPaperBean(workId, markingBean.getId(),
                    markingBean.getBasePaperId(), markingBean.getExamStudentId(), markingBean.getCourseId(),
                    examStudentBean.getOrgCode() == null ? "" : examStudentBean.getOrgCode(),
                    markingBean.getExamRecordDataId(), markingBean.getObjectiveScore(), markingBean.getPaperType(),
                    examCourseRelationBean.getCourseCode(), examStudentBean.getIdentityNumber(),
                    examStudentBean.getStudentName(), examStudentBean.getStudentCode(),
                    examCourseRelationBean.getCourseName(), examStudentBean.getSpecialtyName());
            studentPapers.add(studentPaper);
        }
        SaveStudentPaperReq sreq = new SaveStudentPaperReq();
        sreq.setWorkId(workId);
        sreq.setStudentPaperBeanList(studentPapers);
        studentPaperCloudService.saveStudentPaper(sreq);
        UpdateExamRecordForMarkingBatchNumReq req = new UpdateExamRecordForMarkingBatchNumReq();
        List<Long> ids = studentPapers.stream().map(m -> m.getExamRecordMarkingPk()).collect(Collectors.toList());
        req.setIdList(ids);
        req.setBatchNum(workId + "");
        oeExamRecordForMarkingCloudService.updateExamRecordForMarkingBatchNum(req);
    }
}
