package cn.com.qmth.examcloud.task.service.job;

import java.util.Calendar;
import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cn.com.qmth.examcloud.task.dao.TaskTraceRepo;
import cn.com.qmth.examcloud.web.task.AbstractTask;
import cn.com.qmth.examcloud.web.task.ScheduleJob;
import cn.com.qmth.examcloud.web.task.TaskTracker;

/**
 * 任务跟踪记录清理
 *
 * @author WANGWEI
 * @date 2018年11月7日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Component("taskTraceCleanTask")
public class TaskTraceCleanTask extends AbstractTask {

	@Autowired
	TaskTracker TaskTracker;

	@Autowired
	TaskTraceRepo taskTraceRepo;

	@Override
	public void run(ScheduleJob scheduleJob) throws Exception {
		int amount = 2;
		try {
			amount = Integer.parseInt(scheduleJob.getExt1());
		} catch (Exception e) {
			// ignore
		}

		if (1 > amount || amount > 10) {
			amount = 2;
		}

		// 清理过去amount天前的数据
		Calendar c = Calendar.getInstance();
		c.setTime(new Date());
		c.add(Calendar.DATE, 0 - amount);
		Date d = c.getTime();
		taskTraceRepo.deleteByCreationTimeLessThan(d);
	}

	@Override
	public TaskTracker getTaskTracker() {
		return TaskTracker;
	}
}
