package cn.com.qmth.examcloud.task.starter.config;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.cloud.client.ServiceInstance;
import org.springframework.cloud.client.discovery.DiscoveryClient;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import cn.com.qmth.examcloud.commons.exception.ExamCloudRuntimeException;
import cn.com.qmth.examcloud.web.bootstrap.PropertyHolder;

/**
 * 系统启动
 *
 * @author WANGWEI
 * @date 2018年11月29日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Component
@Order(99)
public class SystemStartup implements ApplicationRunner {

	@Autowired
	private DiscoveryClient discoveryClient;

	public void start() {

		Boolean enabled = PropertyHolder.getBoolean("task.scheduleJob.enabled", true);

		if (!enabled) {
			return;
		}

		String appName = PropertyHolder.getString("spring.application.name");
		if (StringUtils.isNotBlank(appName)) {
			List<ServiceInstance> instances = discoveryClient.getInstances(appName);
			if (!instances.isEmpty()) {
				throw new ExamCloudRuntimeException("multiple task instances!");
			}
		}

	}

	@Override
	public void run(ApplicationArguments args) throws Exception {
		start();
	}

}
